DEVICE P8X32A, XTAL1, PLL16X
FREQ 80_000_000

' Define HUB variables
vidMem  HUB BYTE(6144) = 0

' Define DATA (DATA, WDATA, LDATA)

' Define TASKs
MonoVid  TASK

' Define variables (LONGs only)
X      VAR LONG
xDir   VAR LONG
Y      VAR LONG
yDir   VAR LONG

' Define Subroutines
XPlot   SUB 2

PROGRAM Start

Start:
  PAUSE 100 ' Give tasks time to start

  X = 0
  Y = 0
  xDir = 1
  yDir = 1

  DO
    XPlot x, y
    x = x + xDir
    IF x > 255 THEN
      xdir = -xdir
      x = x + xdir
    ENDIF
    IF x < 0 THEN
      xdir = -xdir
      x = x + xdir
    ENDIF
    y = y + yDir
    IF Y > 190 THEN
      yDir = -yDir
      y = y + yDir
    ENDIF
    IF Y < 0 THEN
      yDir = -yDir
      y = y + yDir
    ENDIF

    PAUSEUS 50
  LOOP
END

SUB XPlot ' X, Y
  GetAddr VidMem, __param4
  __param2 = __param2 << 5 ' 32 bytes per row
  __param4 = __param4 + __param2

  __param2 = __param1 >> 3 ' x div 8
  __param4 = __param4 + __param2

  RDBYTE __param4, __param2
  __param1 = __param1 & 7
  __param3 = 1 << __param1
  __param2 = __param2 XOR __param3
  WRBYTE __param4, __param2
ENDSUB


TASK MonoVid
  addr      VAR LONG ' Holds hub address of video memory being displayed
  line      VAR LONG ' Holds vertical line being generated
  segment   VAR LONG ' Counts longs for each horizonal line
  pixels    VAR LONG ' Holds pixels being displayed
  lineTimer VAR LONG ' Used to generate each line every 64uSec

  SyncPin  PIN 12 OUTPUT ' Sync signal on pin 12 (Demo board)
  VideoPin PIN 14 OUTPUT ' Video (black / white) signal on pin 14 (Demo board)

  ' Setup cnta to use video hardware
  CTRA = %0_00001_111_00000000_000000_000_000000   ' Video PLL x16
  FRQA = $1999_9999   ' = 8 Mhz FROM 80Mhz clock x 16PLL = 128MHz

  ' Setup VSCL
  VSCL = $16_2C0      ' Pixel clock = 128MHz / 22 = 5.818181MHz

  ' Setup I/O pins
  LOW SyncPin
  LOW VideoPin

  ' Setup for initial state
  line = 0
  GetAddr VidMem, addr
  lineTimer = CNT + 5120
  DO
    WaitCnt LineTimer,376 ' 4.7USec for Sync
    SyncPin = 0
    WaitCnt LineTimer,4744 ' Totoal of 5120 clocks @ 80MHz = 64uSec per line
    ' Line 0-2 = Sync; 3-36= Top Blank; 37-228 = Pixels; 229-261 = Bottom Blank
    IF line > 3 THEN
      SyncPin = 1
      PAUSEUS 3 ' Left Margin
      IF line > 36 THEN
        IF line < 229 THEN
          ' Setup VCFG to send one line of pixels
          VCFG = %0_01_0_0_0_000_00000000000_001_0_0100_0000
          FOR segment = 0 TO  7 '8 * 32 = 256 pixels per line
            RdLong addr, pixels
            WaitVid $FF00, pixels
            addr = addr + 4
          NEXT
          ' Stop generating pixels
          WaitVid 0,0
          VCFG = 0
        ENDIF
      ENDIF
    ENDIF
    INC line
    IF line = 262 THEN
      ' Reset for new frame
      line = 0
      GetAddr VidMem, addr
    ENDIF
  LOOP
ENDTASK

